// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: recorder/v1/recorder.proto

package recorderv1connect

import (
	context "context"
	errors "errors"
	connect_go "github.com/bufbuild/connect-go"
	v1 "gitlab.com/wobcom/iot/hemingway-api/go/recorder/v1"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect_go.IsAtLeastVersion0_1_0

const (
	// RecorderServiceName is the fully-qualified name of the RecorderService service.
	RecorderServiceName = "recorder.v1.RecorderService"
)

// RecorderServiceClient is a client for the recorder.v1.RecorderService service.
type RecorderServiceClient interface {
	Record(context.Context, *connect_go.Request[v1.RecordRequest]) (*connect_go.Response[v1.RecordResponse], error)
}

// NewRecorderServiceClient constructs a client for the recorder.v1.RecorderService service. By
// default, it uses the Connect protocol with the binary Protobuf Codec, asks for gzipped responses,
// and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply the
// connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewRecorderServiceClient(httpClient connect_go.HTTPClient, baseURL string, opts ...connect_go.ClientOption) RecorderServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &recorderServiceClient{
		record: connect_go.NewClient[v1.RecordRequest, v1.RecordResponse](
			httpClient,
			baseURL+"/recorder.v1.RecorderService/Record",
			opts...,
		),
	}
}

// recorderServiceClient implements RecorderServiceClient.
type recorderServiceClient struct {
	record *connect_go.Client[v1.RecordRequest, v1.RecordResponse]
}

// Record calls recorder.v1.RecorderService.Record.
func (c *recorderServiceClient) Record(ctx context.Context, req *connect_go.Request[v1.RecordRequest]) (*connect_go.Response[v1.RecordResponse], error) {
	return c.record.CallUnary(ctx, req)
}

// RecorderServiceHandler is an implementation of the recorder.v1.RecorderService service.
type RecorderServiceHandler interface {
	Record(context.Context, *connect_go.Request[v1.RecordRequest]) (*connect_go.Response[v1.RecordResponse], error)
}

// NewRecorderServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewRecorderServiceHandler(svc RecorderServiceHandler, opts ...connect_go.HandlerOption) (string, http.Handler) {
	mux := http.NewServeMux()
	mux.Handle("/recorder.v1.RecorderService/Record", connect_go.NewUnaryHandler(
		"/recorder.v1.RecorderService/Record",
		svc.Record,
		opts...,
	))
	return "/recorder.v1.RecorderService/", mux
}

// UnimplementedRecorderServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedRecorderServiceHandler struct{}

func (UnimplementedRecorderServiceHandler) Record(context.Context, *connect_go.Request[v1.RecordRequest]) (*connect_go.Response[v1.RecordResponse], error) {
	return nil, connect_go.NewError(connect_go.CodeUnimplemented, errors.New("recorder.v1.RecorderService.Record is not implemented"))
}
